Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.xensource.xenapi
Class VM

    java.lang.Object
      com.xensource.xenapi.XenAPIObject
          com.xensource.xenapi.VM

    public class VM

extends XenAPIObject

A virtual machine (or 'guest').

Nested Class Summary
`static class` | `VM.Record` Represents all the fields in a VM

Field Summary
`protected String` | `ref` The XenAPI reference (OpaqueRef) to this object.

Method Summary
`void` | `addTags(Connection c, String value)` Add the given value to the tags field of the given VM.
`void` | `addToBlockedOperations(Connection c, Types.VmOperations key, String value)` Add the given key-value pair to the blocked_operations field of the given VM.
`void` | `addToHVMBootParams(Connection c, String key, String value)` Add the given key-value pair to the HVM/boot_params field of the given VM.
`void` | `addToOtherConfig(Connection c, String key, String value)` Add the given key-value pair to the other_config field of the given VM.
`void` | `addToPlatform(Connection c, String key, String value)` Add the given key-value pair to the platform field of the given VM.
`void` | `addToVCPUsParams(Connection c, String key, String value)` Add the given key-value pair to the VCPUs/params field of the given VM.
`void` | `addToVCPUsParamsLive(Connection c, String key, String value)` Add the given key-value pair to VM.VCPUs_params, and apply that value on the running VM
`Task` | `addToVCPUsParamsLiveAsync(Connection c, String key, String value)` Add the given key-value pair to VM.VCPUs_params, and apply that value on the running VM
`void` | `addToXenstoreData(Connection c, String key, String value)` Add the given key-value pair to the xenstore_data field of the given VM.
`void` | `assertAgile(Connection c)` Returns an error if the VM is not considered agile e.g.
`Task` | `assertAgileAsync(Connection c)` Returns an error if the VM is not considered agile e.g.
`void` | `assertCanBeRecovered(Connection c, Session sessionTo)` Assert whether all SRs required to recover this VM are available.
`Task` | `assertCanBeRecoveredAsync(Connection c, Session sessionTo)` Assert whether all SRs required to recover this VM are available.
`void` | `assertCanBootHere(Connection c, Host host)` Returns an error if the VM could not boot on this host for some reason
`Task` | `assertCanBootHereAsync(Connection c, Host host)` Returns an error if the VM could not boot on this host for some reason
`void` | `assertCanMigrate(Connection c, Map<String,String> dest, Boolean live, Map<VDI,SR> vdiMap, Map<VIF,Network> vifMap, Map<String,String> options)` Assert whether a VM can be migrated to the specified destination.
`Task` | `assertCanMigrateAsync(Connection c, Map<String,String> dest, Boolean live, Map<VDI,SR> vdiMap, Map<VIF,Network> vifMap, Map<String,String> options)` Assert whether a VM can be migrated to the specified destination.
`void` | `assertOperationValid(Connection c, Types.VmOperations op)` Check to see whether this operation is acceptable in the current state of the system, raising an error if the operation is invalid for some reason
`Task` | `assertOperationValidAsync(Connection c, Types.VmOperations op)` Check to see whether this operation is acceptable in the current state of the system, raising an error if the operation is invalid for some reason
`VM` | `checkpoint(Connection c, String newName)` Checkpoints the specified VM, making a new VM.
`Task` | `checkpointAsync(Connection c, String newName)` Checkpoints the specified VM, making a new VM.
`void` | `cleanReboot(Connection c)` Attempt to cleanly shutdown the specified VM (Note: this may not be supported---e.g.
`Task` | `cleanRebootAsync(Connection c)` Attempt to cleanly shutdown the specified VM (Note: this may not be supported---e.g.
`void` | `cleanShutdown(Connection c)` Attempt to cleanly shutdown the specified VM.
`Task` | `cleanShutdownAsync(Connection c)` Attempt to cleanly shutdown the specified VM.
`Long` | `computeMemoryOverhead(Connection c)` Computes the virtualization memory overhead of a VM.
`Task` | `computeMemoryOverheadAsync(Connection c)` Computes the virtualization memory overhead of a VM.
`VM` | `copy(Connection c, String newName, SR sr)` Copied the specified VM, making a new VM.
`Task` | `copyAsync(Connection c, String newName, SR sr)` Copied the specified VM, making a new VM.
`void` | `copyBiosStrings(Connection c, Host host)` Copy the BIOS strings from the given host to this VM
`Task` | `copyBiosStringsAsync(Connection c, Host host)` Copy the BIOS strings from the given host to this VM
`static VM` | `create(Connection c, VM.Record record)` Create a new VM instance, and return its handle.
`static Task` | `createAsync(Connection c, VM.Record record)` Create a new VM instance, and return its handle.
`VM` | `createClone(Connection c, String newName)` Clones the specified VM, making a new VM.
`Task` | `createCloneAsync(Connection c, String newName)` Clones the specified VM, making a new VM.
`Blob` | `createNewBlob(Connection c, String name, String mimeType, Boolean _public)` Create a placeholder for a named binary blob of data that is associated with this VM
`Task` | `createNewBlobAsync(Connection c, String name, String mimeType, Boolean _public)` Create a placeholder for a named binary blob of data that is associated with this VM
`void` | `destroy(Connection c)` Destroy the specified VM.
`Task` | `destroyAsync(Connection c)` Destroy the specified VM.
`boolean` | `equals(Object obj)` If obj is a VM, compares XenAPI references for equality.
`void` | `forgetDataSourceArchives(Connection c, String dataSource)` Forget the recorded statistics related to the specified data source
`Types.OnCrashBehaviour` | `getActionsAfterCrash(Connection c)` Get the actions/after_crash field of the given VM.
`Types.OnNormalExit` | `getActionsAfterReboot(Connection c)` Get the actions/after_reboot field of the given VM.
`Types.OnNormalExit` | `getActionsAfterShutdown(Connection c)` Get the actions/after_shutdown field of the given VM.
`Host` | `getAffinity(Connection c)` Get the affinity field of the given VM.
`static Set<VM>` | `getAll(Connection c)` Return a list of all the VMs known to the system.
`Set<Types.VmOperations>` | `getAllowedOperations(Connection c)` Get the allowed_operations field of the given VM.
`Set<String>` | `getAllowedVBDDevices(Connection c)` Returns a list of the allowed values that a VBD device field can take
`Set<String>` | `getAllowedVIFDevices(Connection c)` Returns a list of the allowed values that a VIF device field can take
`static Map<VM,VM.Record>` | `getAllRecords(Connection c)` Return a map of VM references to VM records for all VMs known to the system.
`VMAppliance` | `getAppliance(Connection c)` Get the appliance field of the given VM.
`Set<PCI>` | `getAttachedPCIs(Connection c)` Get the attached_PCIs field of the given VM.
`Map<String,String>` | `getBiosStrings(Connection c)` Get the bios_strings field of the given VM.
`Map<String,Blob>` | `getBlobs(Connection c)` Get the blobs field of the given VM.
`Map<Types.VmOperations,String>` | `getBlockedOperations(Connection c)` Get the blocked_operations field of the given VM.
`VM.Record` | `getBootRecord(Connection c)` Returns a record describing the VM's dynamic state, initialised when the VM boots and updated to reflect runtime configuration changes e.g.
`static Set<VM>` | `getByNameLabel(Connection c, String label)` Get all the VM instances with the given label.
`static VM` | `getByUuid(Connection c, String uuid)` Get a reference to the VM instance with the specified UUID.
`Set<VM>` | `getChildren(Connection c)` Get the children field of the given VM.
`Set<Console>` | `getConsoles(Connection c)` Get the consoles field of the given VM.
`Boolean` | `getCooperative(Connection c)` Deprecated.
`Task` | `getCooperativeAsync(Connection c)` Deprecated.
`Set<Crashdump>` | `getCrashDumps(Connection c)` Get the crash_dumps field of the given VM.
`Map<String,Types.VmOperations>` | `getCurrentOperations(Connection c)` Get the current_operations field of the given VM.
`Set<DataSource.Record>` | `getDataSources(Connection c)`
`String` | `getDomarch(Connection c)` Get the domarch field of the given VM.
`Long` | `getDomid(Connection c)` Get the domid field of the given VM.
`String` | `getGenerationId(Connection c)` Get the generation_id field of the given VM.
`VMGuestMetrics` | `getGuestMetrics(Connection c)` Get the guest_metrics field of the given VM.
`Boolean` | `getHaAlwaysRun(Connection c)` Deprecated.
`String` | `getHaRestartPriority(Connection c)` Get the ha_restart_priority field of the given VM.
`Map<String,String>` | `getHVMBootParams(Connection c)` Get the HVM/boot_params field of the given VM.
`String` | `getHVMBootPolicy(Connection c)` Get the HVM/boot_policy field of the given VM.
`Double` | `getHVMShadowMultiplier(Connection c)` Get the HVM/shadow_multiplier field of the given VM.
`Boolean` | `getIsASnapshot(Connection c)` Get the is_a_snapshot field of the given VM.
`Boolean` | `getIsATemplate(Connection c)` Get the is_a_template field of the given VM.
`Boolean` | `getIsControlDomain(Connection c)` Get the is_control_domain field of the given VM.
`Boolean` | `getIsSnapshotFromVmpp(Connection c)` Deprecated.
`Map<String,String>` | `getLastBootCPUFlags(Connection c)` Get the last_boot_CPU_flags field of the given VM.
`String` | `getLastBootedRecord(Connection c)` Get the last_booted_record field of the given VM.
`Long` | `getMemoryDynamicMax(Connection c)` Get the memory/dynamic_max field of the given VM.
`Long` | `getMemoryDynamicMin(Connection c)` Get the memory/dynamic_min field of the given VM.
`Long` | `getMemoryOverhead(Connection c)` Get the memory/overhead field of the given VM.
`Long` | `getMemoryStaticMax(Connection c)` Get the memory/static_max field of the given VM.
`Long` | `getMemoryStaticMin(Connection c)` Get the memory/static_min field of the given VM.
`Long` | `getMemoryTarget(Connection c)` Deprecated.
`VMMetrics` | `getMetrics(Connection c)` Get the metrics field of the given VM.
`String` | `getNameDescription(Connection c)` Get the name/description field of the given VM.
`String` | `getNameLabel(Connection c)` Get the name/label field of the given VM.
`Long` | `getOrder(Connection c)` Get the order field of the given VM.
`Map<String,String>` | `getOtherConfig(Connection c)` Get the other_config field of the given VM.
`VM` | `getParent(Connection c)` Get the parent field of the given VM.
`String` | `getPCIBus(Connection c)` Deprecated.
`Map<String,String>` | `getPlatform(Connection c)` Get the platform field of the given VM.
`Set<Host>` | `getPossibleHosts(Connection c)` Return the list of hosts on which this VM may run.
`Task` | `getPossibleHostsAsync(Connection c)` Return the list of hosts on which this VM may run.
`Types.VmPowerState` | `getPowerState(Connection c)` Get the power_state field of the given VM.
`VMPP` | `getProtectionPolicy(Connection c)` Deprecated.
`String` | `getPVArgs(Connection c)` Get the PV/args field of the given VM.
`String` | `getPVBootloader(Connection c)` Get the PV/bootloader field of the given VM.
`String` | `getPVBootloaderArgs(Connection c)` Get the PV/bootloader_args field of the given VM.
`String` | `getPVKernel(Connection c)` Get the PV/kernel field of the given VM.
`String` | `getPVLegacyArgs(Connection c)` Get the PV/legacy_args field of the given VM.
`String` | `getPVRamdisk(Connection c)` Get the PV/ramdisk field of the given VM.
`String` | `getRecommendations(Connection c)` Get the recommendations field of the given VM.
`VM.Record` | `getRecord(Connection c)` Get a record containing the current state of the given VM.
`Host` | `getResidentOn(Connection c)` Get the resident_on field of the given VM.
`Long` | `getShutdownDelay(Connection c)` Get the shutdown_delay field of the given VM.
`Map<String,String>` | `getSnapshotInfo(Connection c)` Get the snapshot_info field of the given VM.
`String` | `getSnapshotMetadata(Connection c)` Get the snapshot_metadata field of the given VM.
`VM` | `getSnapshotOf(Connection c)` Get the snapshot_of field of the given VM.
`Set<VM>` | `getSnapshots(Connection c)` Get the snapshots field of the given VM.
`Date` | `getSnapshotTime(Connection c)` Get the snapshot_time field of the given VM.
`Long` | `getStartDelay(Connection c)` Get the start_delay field of the given VM.
`SR` | `getSuspendSR(Connection c)` Get the suspend_SR field of the given VM.
`VDI` | `getSuspendVDI(Connection c)` Get the suspend_VDI field of the given VM.
`Set<String>` | `getTags(Connection c)` Get the tags field of the given VM.
`String` | `getTransportableSnapshotId(Connection c)` Get the transportable_snapshot_id field of the given VM.
`Long` | `getUserVersion(Connection c)` Get the user_version field of the given VM.
`String` | `getUuid(Connection c)` Get the uuid field of the given VM.
`Set<VBD>` | `getVBDs(Connection c)` Get the VBDs field of the given VM.
`Long` | `getVCPUsAtStartup(Connection c)` Get the VCPUs/at_startup field of the given VM.
`Long` | `getVCPUsMax(Connection c)` Get the VCPUs/max field of the given VM.
`Map<String,String>` | `getVCPUsParams(Connection c)` Get the VCPUs/params field of the given VM.
`Long` | `getVersion(Connection c)` Get the version field of the given VM.
`Set<VGPU>` | `getVGPUs(Connection c)` Get the VGPUs field of the given VM.
`Set<VIF>` | `getVIFs(Connection c)` Get the VIFs field of the given VM.
`Set<VTPM>` | `getVTPMs(Connection c)` Get the VTPMs field of the given VM.
`Map<String,String>` | `getXenstoreData(Connection c)` Get the xenstore_data field of the given VM.
`void` | `hardReboot(Connection c)` Stop executing the specified VM without attempting a clean shutdown and immediately restart the VM.
`Task` | `hardRebootAsync(Connection c)` Stop executing the specified VM without attempting a clean shutdown and immediately restart the VM.
`void` | `hardShutdown(Connection c)` Stop executing the specified VM without attempting a clean shutdown.
`Task` | `hardShutdownAsync(Connection c)` Stop executing the specified VM without attempting a clean shutdown.
`int` | `hashCode()`
`static void` | `importConvert(Connection c, String type, String username, String password, SR sr, Map<String,String> remoteConfig)` Import using a conversion service.
`static Task` | `importConvertAsync(Connection c, String type, String username, String password, SR sr, Map<String,String> remoteConfig)` Import using a conversion service.
`Long` | `maximiseMemory(Connection c, Long total, Boolean approximate)` Returns the maximum amount of guest memory which will fit, together with overheads, in the supplied amount of physical memory.
`Task` | `maximiseMemoryAsync(Connection c, Long total, Boolean approximate)` Returns the maximum amount of guest memory which will fit, together with overheads, in the supplied amount of physical memory.
`void` | `migrateSend(Connection c, Map<String,String> dest, Boolean live, Map<VDI,SR> vdiMap, Map<VIF,Network> vifMap, Map<String,String> options)` Migrate the VM to another host.
`Task` | `migrateSendAsync(Connection c, Map<String,String> dest, Boolean live, Map<VDI,SR> vdiMap, Map<VIF,Network> vifMap, Map<String,String> options)` Migrate the VM to another host.
`void` | `pause(Connection c)` Pause the specified VM.
`Task` | `pauseAsync(Connection c)` Pause the specified VM.
`void` | `poolMigrate(Connection c, Host host, Map<String,String> options)` Migrate a VM to another Host.
`Task` | `poolMigrateAsync(Connection c, Host host, Map<String,String> options)` Migrate a VM to another Host.
`void` | `powerStateReset(Connection c)` Reset the power-state of the VM to halted in the database only.
`Task` | `powerStateResetAsync(Connection c)` Reset the power-state of the VM to halted in the database only.
`void` | `provision(Connection c)` Inspects the disk configuration contained within the VM's other_config, creates VDIs and VBDs and then executes any applicable post-install script.
`Task` | `provisionAsync(Connection c)` Inspects the disk configuration contained within the VM's other_config, creates VDIs and VBDs and then executes any applicable post-install script.
`Double` | `queryDataSource(Connection c, String dataSource)` Query the latest value of the specified data source
`Map<String,String>` | `queryServices(Connection c)` Query the system services advertised by this VM and register them.
`Task` | `queryServicesAsync(Connection c)` Query the system services advertised by this VM and register them.
`void` | `recordDataSource(Connection c, String dataSource)` Start recording the specified data source
`void` | `recover(Connection c, Session sessionTo, Boolean force)` Recover the VM
`Task` | `recoverAsync(Connection c, Session sessionTo, Boolean force)` Recover the VM
`void` | `removeFromBlockedOperations(Connection c, Types.VmOperations key)` Remove the given key and its corresponding value from the blocked_operations field of the given VM.
`void` | `removeFromHVMBootParams(Connection c, String key)` Remove the given key and its corresponding value from the HVM/boot_params field of the given VM.
`void` | `removeFromOtherConfig(Connection c, String key)` Remove the given key and its corresponding value from the other_config field of the given VM.
`void` | `removeFromPlatform(Connection c, String key)` Remove the given key and its corresponding value from the platform field of the given VM.
`void` | `removeFromVCPUsParams(Connection c, String key)` Remove the given key and its corresponding value from the VCPUs/params field of the given VM.
`void` | `removeFromXenstoreData(Connection c, String key)` Remove the given key and its corresponding value from the xenstore_data field of the given VM.
`void` | `removeTags(Connection c, String value)` Remove the given value from the tags field of the given VM.
`void` | `resume(Connection c, Boolean startPaused, Boolean force)` Awaken the specified VM and resume it.
`Task` | `resumeAsync(Connection c, Boolean startPaused, Boolean force)` Awaken the specified VM and resume it.
`void` | `resumeOn(Connection c, Host host, Boolean startPaused, Boolean force)` Awaken the specified VM and resume it on a particular Host.
`Task` | `resumeOnAsync(Connection c, Host host, Boolean startPaused, Boolean force)` Awaken the specified VM and resume it on a particular Host.
`Map<Host,Set<String>>` | `retrieveWlbRecommendations(Connection c)` Returns mapping of hosts to ratings, indicating the suitability of starting the VM at that location according to wlb.
`Task` | `retrieveWlbRecommendationsAsync(Connection c)` Returns mapping of hosts to ratings, indicating the suitability of starting the VM at that location according to wlb.
`void` | `revert(Connection c)` Reverts the specified VM to a previous state.
`Task` | `revertAsync(Connection c)` Reverts the specified VM to a previous state.
`void` | `sendSysrq(Connection c, String key)` Send the given key as a sysrq to this VM.
`Task` | `sendSysrqAsync(Connection c, String key)` Send the given key as a sysrq to this VM.
`void` | `sendTrigger(Connection c, String trigger)` Send the named trigger to this VM.
`Task` | `sendTriggerAsync(Connection c, String trigger)` Send the named trigger to this VM.
`void` | `setActionsAfterCrash(Connection c, Types.OnCrashBehaviour afterCrash)` Set the actions/after_crash field of the given VM.
`void` | `setActionsAfterReboot(Connection c, Types.OnNormalExit afterReboot)` Set the actions/after_reboot field of the given VM.
`void` | `setActionsAfterShutdown(Connection c, Types.OnNormalExit afterShutdown)` Set the actions/after_shutdown field of the given VM.
`void` | `setAffinity(Connection c, Host affinity)` Set the affinity field of the given VM.
`void` | `setAppliance(Connection c, VMAppliance value)` Assign this VM to an appliance.
`Task` | `setApplianceAsync(Connection c, VMAppliance value)` Assign this VM to an appliance.
`void` | `setBlockedOperations(Connection c, Map<Types.VmOperations,String> blockedOperations)` Set the blocked_operations field of the given VM.
`void` | `setHaAlwaysRun(Connection c, Boolean value)` Deprecated.
`void` | `setHaRestartPriority(Connection c, String value)` Set the value of the ha_restart_priority field
`void` | `setHVMBootParams(Connection c, Map<String,String> bootParams)` Set the HVM/boot_params field of the given VM.
`void` | `setHVMBootPolicy(Connection c, String bootPolicy)` Set the HVM/boot_policy field of the given VM.
`void` | `setHVMShadowMultiplier(Connection c, Double value)` Set the shadow memory multiplier on a halted VM
`void` | `setIsATemplate(Connection c, Boolean isATemplate)` Set the is_a_template field of the given VM.
`void` | `setMemoryDynamicMax(Connection c, Long value)` Set the value of the memory_dynamic_max field
`void` | `setMemoryDynamicMin(Connection c, Long value)` Set the value of the memory_dynamic_min field
`void` | `setMemoryDynamicRange(Connection c, Long min, Long max)` Set the minimum and maximum amounts of physical memory the VM is allowed to use.
`Task` | `setMemoryDynamicRangeAsync(Connection c, Long min, Long max)` Set the minimum and maximum amounts of physical memory the VM is allowed to use.
`void` | `setMemoryLimits(Connection c, Long staticMin, Long staticMax, Long dynamicMin, Long dynamicMax)` Set the memory limits of this VM.
`Task` | `setMemoryLimitsAsync(Connection c, Long staticMin, Long staticMax, Long dynamicMin, Long dynamicMax)` Set the memory limits of this VM.
`void` | `setMemoryStaticMax(Connection c, Long value)` Set the value of the memory_static_max field
`void` | `setMemoryStaticMin(Connection c, Long value)` Set the value of the memory_static_min field
`void` | `setMemoryStaticRange(Connection c, Long min, Long max)` Set the static (ie boot-time) range of virtual memory that the VM is allowed to use.
`Task` | `setMemoryStaticRangeAsync(Connection c, Long min, Long max)` Set the static (ie boot-time) range of virtual memory that the VM is allowed to use.
`void` | `setMemoryTargetLive(Connection c, Long target)` Deprecated.
`Task` | `setMemoryTargetLiveAsync(Connection c, Long target)` Deprecated.
`void` | `setNameDescription(Connection c, String description)` Set the name/description field of the given VM.
`void` | `setNameLabel(Connection c, String label)` Set the name/label field of the given VM.
`void` | `setOrder(Connection c, Long value)` Set this VM's boot order
`Task` | `setOrderAsync(Connection c, Long value)` Set this VM's boot order
`void` | `setOtherConfig(Connection c, Map<String,String> otherConfig)` Set the other_config field of the given VM.
`void` | `setPCIBus(Connection c, String PCIBus)` Deprecated.
`void` | `setPlatform(Connection c, Map<String,String> platform)` Set the platform field of the given VM.
`void` | `setProtectionPolicy(Connection c, VMPP value)` Set the value of the protection_policy field
`void` | `setPVArgs(Connection c, String args)` Set the PV/args field of the given VM.
`void` | `setPVBootloader(Connection c, String bootloader)` Set the PV/bootloader field of the given VM.
`void` | `setPVBootloaderArgs(Connection c, String bootloaderArgs)` Set the PV/bootloader_args field of the given VM.
`void` | `setPVKernel(Connection c, String kernel)` Set the PV/kernel field of the given VM.
`void` | `setPVLegacyArgs(Connection c, String legacyArgs)` Set the PV/legacy_args field of the given VM.
`void` | `setPVRamdisk(Connection c, String ramdisk)` Set the PV/ramdisk field of the given VM.
`void` | `setRecommendations(Connection c, String recommendations)` Set the recommendations field of the given VM.
`void` | `setShadowMultiplierLive(Connection c, Double multiplier)` Set the shadow memory multiplier on a running VM
`Task` | `setShadowMultiplierLiveAsync(Connection c, Double multiplier)` Set the shadow memory multiplier on a running VM
`void` | `setShutdownDelay(Connection c, Long value)` Set this VM's shutdown delay in seconds
`Task` | `setShutdownDelayAsync(Connection c, Long value)` Set this VM's shutdown delay in seconds
`void` | `setStartDelay(Connection c, Long value)` Set this VM's start delay in seconds
`Task` | `setStartDelayAsync(Connection c, Long value)` Set this VM's start delay in seconds
`void` | `setSuspendSR(Connection c, SR suspendSR)` Set the suspend_SR field of the given VM.
`void` | `setSuspendVDI(Connection c, VDI value)` Set this VM's suspend VDI, which must be indentical to its current one
`Task` | `setSuspendVDIAsync(Connection c, VDI value)` Set this VM's suspend VDI, which must be indentical to its current one
`void` | `setTags(Connection c, Set<String> tags)` Set the tags field of the given VM.
`void` | `setUserVersion(Connection c, Long userVersion)` Set the user_version field of the given VM.
`void` | `setVCPUsAtStartup(Connection c, Long value)` Set the number of startup VCPUs for a halted VM
`void` | `setVCPUsMax(Connection c, Long value)` Set the maximum number of VCPUs for a halted VM
`void` | `setVCPUsNumberLive(Connection c, Long nvcpu)` Set the number of VCPUs for a running VM
`Task` | `setVCPUsNumberLiveAsync(Connection c, Long nvcpu)` Set the number of VCPUs for a running VM
`void` | `setVCPUsParams(Connection c, Map<String,String> params)` Set the VCPUs/params field of the given VM.
`void` | `setXenstoreData(Connection c, Map<String,String> xenstoreData)` Set the xenstore_data field of the given VM.
`void` | `shutdown(Connection c)` Attempts to first clean shutdown a VM and if it should fail then perform a hard shutdown on it.
`Task` | `shutdownAsync(Connection c)` Attempts to first clean shutdown a VM and if it should fail then perform a hard shutdown on it.
`VM` | `snapshot(Connection c, String newName)` Snapshots the specified VM, making a new VM.
`Task` | `snapshotAsync(Connection c, String newName)` Snapshots the specified VM, making a new VM.
`VM` | `snapshotWithQuiesce(Connection c, String newName)` Snapshots the specified VM with quiesce, making a new VM.
`Task` | `snapshotWithQuiesceAsync(Connection c, String newName)` Snapshots the specified VM with quiesce, making a new VM.
`void` | `start(Connection c, Boolean startPaused, Boolean force)` Start the specified VM.
`Task` | `startAsync(Connection c, Boolean startPaused, Boolean force)` Start the specified VM.
`void` | `startOn(Connection c, Host host, Boolean startPaused, Boolean force)` Start the specified VM on a particular host.
`Task` | `startOnAsync(Connection c, Host host, Boolean startPaused, Boolean force)` Start the specified VM on a particular host.
`void` | `suspend(Connection c)` Suspend the specified VM to disk.
`Task` | `suspendAsync(Connection c)` Suspend the specified VM to disk.
`String` | `toWireString()`
`void` | `unpause(Connection c)` Resume the specified VM.
`Task` | `unpauseAsync(Connection c)` Resume the specified VM.
`void` | `updateAllowedOperations(Connection c)` Recomputes the list of acceptable operations
`Task` | `updateAllowedOperationsAsync(Connection c)` Recomputes the list of acceptable operations
`void` | `waitMemoryTargetLive(Connection c)` Deprecated.
`Task` | `waitMemoryTargetLiveAsync(Connection c)` Deprecated.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ref

    protected final String ref

  The XenAPI reference (OpaqueRef) to this object.

Method Detail

### toWireString

    public String toWireString()

  Specified by:
    `toWireString` in class `XenAPIObject`
  Returns:
    The XenAPI reference (OpaqueRef) to this object.

### equals

    public boolean equals(Object obj)

  If obj is a VM, compares XenAPI references for equality.

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### getRecord

    public VM.Record getRecord(Connection c)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Get a record containing the current state of the given VM.

  Returns:
    all fields from the object
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getByUuid

    public static VM getByUuid(Connection c,
                               String uuid)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Get a reference to the VM instance with the specified UUID.

  Parameters:
    `uuid` - UUID of object to return
  Returns:
    reference to the object
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### createAsync

    public static Task createAsync(Connection c,
                                   VM.Record record)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Create a new VM instance, and return its handle.

  Parameters:
    `record` - All constructor arguments
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### create

    public static VM create(Connection c,
                            VM.Record record)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Create a new VM instance, and return its handle.

  Parameters:
    `record` - All constructor arguments
  Returns:
    reference to the newly created object
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### destroyAsync

    public Task destroyAsync(Connection c)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException

  Destroy the specified VM. The VM is completely removed from the system. This function can only be called when the VM is in the Halted State.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### destroy

    public void destroy(Connection c)
                 throws Types.BadServerResponse,
                        Types.XenAPIException,
                        org.apache.xmlrpc.XmlRpcException

  Destroy the specified VM. The VM is completely removed from the system. This function can only be called when the VM is in the Halted State.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getByNameLabel

    public static Set<VM> getByNameLabel(Connection c,
                                         String label)
                                  throws Types.BadServerResponse,
                                         Types.XenAPIException,
                                         org.apache.xmlrpc.XmlRpcException

  Get all the VM instances with the given label.

  Parameters:
    `label` - label of object to return
  Returns:
    references to objects with matching names
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getUuid

    public String getUuid(Connection c)
                   throws Types.BadServerResponse,
                          Types.XenAPIException,
                          org.apache.xmlrpc.XmlRpcException

  Get the uuid field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getAllowedOperations

    public Set<Types.VmOperations> getAllowedOperations(Connection c)
                                                 throws Types.BadServerResponse,
                                                        Types.XenAPIException,
                                                        org.apache.xmlrpc.XmlRpcException

  Get the allowed_operations field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getCurrentOperations

    public Map<String,Types.VmOperations> getCurrentOperations(Connection c)
                                                        throws Types.BadServerResponse,
                                                               Types.XenAPIException,
                                                               org.apache.xmlrpc.XmlRpcException

  Get the current_operations field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPowerState

    public Types.VmPowerState getPowerState(Connection c)
                                     throws Types.BadServerResponse,
                                            Types.XenAPIException,
                                            org.apache.xmlrpc.XmlRpcException

  Get the power_state field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getNameLabel

    public String getNameLabel(Connection c)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Get the name/label field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getNameDescription

    public String getNameDescription(Connection c)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Get the name/description field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getUserVersion

    public Long getUserVersion(Connection c)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Get the user_version field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getIsATemplate

    public Boolean getIsATemplate(Connection c)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Get the is_a_template field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getSuspendVDI

    public VDI getSuspendVDI(Connection c)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException

  Get the suspend_VDI field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getResidentOn

    public Host getResidentOn(Connection c)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException

  Get the resident_on field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getAffinity

    public Host getAffinity(Connection c)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Get the affinity field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getMemoryOverhead

    public Long getMemoryOverhead(Connection c)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Get the memory/overhead field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getMemoryTarget

    @Deprecated
    public Long getMemoryTarget(Connection c)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Get the memory/target field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getMemoryStaticMax

    public Long getMemoryStaticMax(Connection c)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Get the memory/static_max field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getMemoryDynamicMax

    public Long getMemoryDynamicMax(Connection c)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Get the memory/dynamic_max field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getMemoryDynamicMin

    public Long getMemoryDynamicMin(Connection c)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Get the memory/dynamic_min field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getMemoryStaticMin

    public Long getMemoryStaticMin(Connection c)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Get the memory/static_min field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getVCPUsParams

    public Map<String,String> getVCPUsParams(Connection c)
                                      throws Types.BadServerResponse,
                                             Types.XenAPIException,
                                             org.apache.xmlrpc.XmlRpcException

  Get the VCPUs/params field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getVCPUsMax

    public Long getVCPUsMax(Connection c)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Get the VCPUs/max field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getVCPUsAtStartup

    public Long getVCPUsAtStartup(Connection c)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Get the VCPUs/at_startup field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getActionsAfterShutdown

    public Types.OnNormalExit getActionsAfterShutdown(Connection c)
                                               throws Types.BadServerResponse,
                                                      Types.XenAPIException,
                                                      org.apache.xmlrpc.XmlRpcException

  Get the actions/after_shutdown field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getActionsAfterReboot

    public Types.OnNormalExit getActionsAfterReboot(Connection c)
                                             throws Types.BadServerResponse,
                                                    Types.XenAPIException,
                                                    org.apache.xmlrpc.XmlRpcException

  Get the actions/after_reboot field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getActionsAfterCrash

    public Types.OnCrashBehaviour getActionsAfterCrash(Connection c)
                                                throws Types.BadServerResponse,
                                                       Types.XenAPIException,
                                                       org.apache.xmlrpc.XmlRpcException

  Get the actions/after_crash field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getConsoles

    public Set<Console> getConsoles(Connection c)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Get the consoles field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getVIFs

    public Set<VIF> getVIFs(Connection c)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Get the VIFs field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getVBDs

    public Set<VBD> getVBDs(Connection c)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Get the VBDs field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getCrashDumps

    public Set<Crashdump> getCrashDumps(Connection c)
                                 throws Types.BadServerResponse,
                                        Types.XenAPIException,
                                        org.apache.xmlrpc.XmlRpcException

  Get the crash_dumps field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getVTPMs

    public Set<VTPM> getVTPMs(Connection c)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException

  Get the VTPMs field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPVBootloader

    public String getPVBootloader(Connection c)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Get the PV/bootloader field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPVKernel

    public String getPVKernel(Connection c)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException

  Get the PV/kernel field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPVRamdisk

    public String getPVRamdisk(Connection c)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Get the PV/ramdisk field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPVArgs

    public String getPVArgs(Connection c)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Get the PV/args field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPVBootloaderArgs

    public String getPVBootloaderArgs(Connection c)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Get the PV/bootloader_args field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPVLegacyArgs

    public String getPVLegacyArgs(Connection c)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Get the PV/legacy_args field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getHVMBootPolicy

    public String getHVMBootPolicy(Connection c)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Get the HVM/boot_policy field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getHVMBootParams

    public Map<String,String> getHVMBootParams(Connection c)
                                        throws Types.BadServerResponse,
                                               Types.XenAPIException,
                                               org.apache.xmlrpc.XmlRpcException

  Get the HVM/boot_params field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getHVMShadowMultiplier

    public Double getHVMShadowMultiplier(Connection c)
                                  throws Types.BadServerResponse,
                                         Types.XenAPIException,
                                         org.apache.xmlrpc.XmlRpcException

  Get the HVM/shadow_multiplier field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPlatform

    public Map<String,String> getPlatform(Connection c)
                                   throws Types.BadServerResponse,
                                          Types.XenAPIException,
                                          org.apache.xmlrpc.XmlRpcException

  Get the platform field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPCIBus

    @Deprecated
    public String getPCIBus(Connection c)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Get the PCI_bus field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getOtherConfig

    public Map<String,String> getOtherConfig(Connection c)
                                      throws Types.BadServerResponse,
                                             Types.XenAPIException,
                                             org.apache.xmlrpc.XmlRpcException

  Get the other_config field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getDomid

    public Long getDomid(Connection c)
                  throws Types.BadServerResponse,
                         Types.XenAPIException,
                         org.apache.xmlrpc.XmlRpcException

  Get the domid field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getDomarch

    public String getDomarch(Connection c)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException

  Get the domarch field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getLastBootCPUFlags

    public Map<String,String> getLastBootCPUFlags(Connection c)
                                           throws Types.BadServerResponse,
                                                  Types.XenAPIException,
                                                  org.apache.xmlrpc.XmlRpcException

  Get the last_boot_CPU_flags field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getIsControlDomain

    public Boolean getIsControlDomain(Connection c)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Get the is_control_domain field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getMetrics

    public VMMetrics getMetrics(Connection c)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException

  Get the metrics field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getGuestMetrics

    public VMGuestMetrics getGuestMetrics(Connection c)
                                   throws Types.BadServerResponse,
                                          Types.XenAPIException,
                                          org.apache.xmlrpc.XmlRpcException

  Get the guest_metrics field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getLastBootedRecord

    public String getLastBootedRecord(Connection c)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Get the last_booted_record field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getRecommendations

    public String getRecommendations(Connection c)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Get the recommendations field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getXenstoreData

    public Map<String,String> getXenstoreData(Connection c)
                                       throws Types.BadServerResponse,
                                              Types.XenAPIException,
                                              org.apache.xmlrpc.XmlRpcException

  Get the xenstore_data field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getHaAlwaysRun

    @Deprecated
    public Boolean getHaAlwaysRun(Connection c)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Get the ha_always_run field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getHaRestartPriority

    public String getHaRestartPriority(Connection c)
                                throws Types.BadServerResponse,
                                       Types.XenAPIException,
                                       org.apache.xmlrpc.XmlRpcException

  Get the ha_restart_priority field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getIsASnapshot

    public Boolean getIsASnapshot(Connection c)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Get the is_a_snapshot field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getSnapshotOf

    public VM getSnapshotOf(Connection c)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Get the snapshot_of field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getSnapshots

    public Set<VM> getSnapshots(Connection c)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException

  Get the snapshots field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getSnapshotTime

    public Date getSnapshotTime(Connection c)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException

  Get the snapshot_time field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getTransportableSnapshotId

    public String getTransportableSnapshotId(Connection c)
                                      throws Types.BadServerResponse,
                                             Types.XenAPIException,
                                             org.apache.xmlrpc.XmlRpcException

  Get the transportable_snapshot_id field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getBlobs

    public Map<String,Blob> getBlobs(Connection c)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Get the blobs field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getTags

    public Set<String> getTags(Connection c)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Get the tags field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getBlockedOperations

    public Map<Types.VmOperations,String> getBlockedOperations(Connection c)
                                                        throws Types.BadServerResponse,
                                                               Types.XenAPIException,
                                                               org.apache.xmlrpc.XmlRpcException

  Get the blocked_operations field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getSnapshotInfo

    public Map<String,String> getSnapshotInfo(Connection c)
                                       throws Types.BadServerResponse,
                                              Types.XenAPIException,
                                              org.apache.xmlrpc.XmlRpcException

  Get the snapshot_info field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getSnapshotMetadata

    public String getSnapshotMetadata(Connection c)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Get the snapshot_metadata field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getParent

    public VM getParent(Connection c)
                 throws Types.BadServerResponse,
                        Types.XenAPIException,
                        org.apache.xmlrpc.XmlRpcException

  Get the parent field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getChildren

    public Set<VM> getChildren(Connection c)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Get the children field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getBiosStrings

    public Map<String,String> getBiosStrings(Connection c)
                                      throws Types.BadServerResponse,
                                             Types.XenAPIException,
                                             org.apache.xmlrpc.XmlRpcException

  Get the bios_strings field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getProtectionPolicy

    @Deprecated
    public VMPP getProtectionPolicy(Connection c)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Get the protection_policy field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getIsSnapshotFromVmpp

    @Deprecated
    public Boolean getIsSnapshotFromVmpp(Connection c)
                                  throws Types.BadServerResponse,
                                         Types.XenAPIException,
                                         org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Get the is_snapshot_from_vmpp field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getAppliance

    public VMAppliance getAppliance(Connection c)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Get the appliance field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getStartDelay

    public Long getStartDelay(Connection c)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException

  Get the start_delay field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getShutdownDelay

    public Long getShutdownDelay(Connection c)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException

  Get the shutdown_delay field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getOrder

    public Long getOrder(Connection c)
                  throws Types.BadServerResponse,
                         Types.XenAPIException,
                         org.apache.xmlrpc.XmlRpcException

  Get the order field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getVGPUs

    public Set<VGPU> getVGPUs(Connection c)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException

  Get the VGPUs field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getAttachedPCIs

    public Set<PCI> getAttachedPCIs(Connection c)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Get the attached_PCIs field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getSuspendSR

    public SR getSuspendSR(Connection c)
                    throws Types.BadServerResponse,
                           Types.XenAPIException,
                           org.apache.xmlrpc.XmlRpcException

  Get the suspend_SR field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getVersion

    public Long getVersion(Connection c)
                    throws Types.BadServerResponse,
                           Types.XenAPIException,
                           org.apache.xmlrpc.XmlRpcException

  Get the version field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getGenerationId

    public String getGenerationId(Connection c)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Get the generation_id field of the given VM.

  Returns:
    value of the field
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setNameLabel

    public void setNameLabel(Connection c,
                             String label)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException

  Set the name/label field of the given VM.

  Parameters:
    `label` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setNameDescription

    public void setNameDescription(Connection c,
                                   String description)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Set the name/description field of the given VM.

  Parameters:
    `description` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setUserVersion

    public void setUserVersion(Connection c,
                               Long userVersion)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Set the user_version field of the given VM.

  Parameters:
    `userVersion` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setIsATemplate

    public void setIsATemplate(Connection c,
                               Boolean isATemplate)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Set the is_a_template field of the given VM.

  Parameters:
    `isATemplate` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setAffinity

    public void setAffinity(Connection c,
                            Host affinity)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Set the affinity field of the given VM.

  Parameters:
    `affinity` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setVCPUsParams

    public void setVCPUsParams(Connection c,
                               Map<String,String> params)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Set the VCPUs/params field of the given VM.

  Parameters:
    `params` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### addToVCPUsParams

    public void addToVCPUsParams(Connection c,
                                 String key,
                                 String value)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException

  Add the given key-value pair to the VCPUs/params field of the given VM.

  Parameters:
    `key` - Key to add
    `value` - Value to add
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### removeFromVCPUsParams

    public void removeFromVCPUsParams(Connection c,
                                      String key)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Remove the given key and its corresponding value from the VCPUs/params field of the given VM. If the key is not in that Map, then do nothing.

  Parameters:
    `key` - Key to remove
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setActionsAfterShutdown

    public void setActionsAfterShutdown(Connection c,
                                        Types.OnNormalExit afterShutdown)
                                 throws Types.BadServerResponse,
                                        Types.XenAPIException,
                                        org.apache.xmlrpc.XmlRpcException

  Set the actions/after_shutdown field of the given VM.

  Parameters:
    `afterShutdown` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setActionsAfterReboot

    public void setActionsAfterReboot(Connection c,
                                      Types.OnNormalExit afterReboot)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Set the actions/after_reboot field of the given VM.

  Parameters:
    `afterReboot` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setActionsAfterCrash

    public void setActionsAfterCrash(Connection c,
                                     Types.OnCrashBehaviour afterCrash)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Set the actions/after_crash field of the given VM.

  Parameters:
    `afterCrash` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setPVBootloader

    public void setPVBootloader(Connection c,
                                String bootloader)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException

  Set the PV/bootloader field of the given VM.

  Parameters:
    `bootloader` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setPVKernel

    public void setPVKernel(Connection c,
                            String kernel)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Set the PV/kernel field of the given VM.

  Parameters:
    `kernel` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setPVRamdisk

    public void setPVRamdisk(Connection c,
                             String ramdisk)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException

  Set the PV/ramdisk field of the given VM.

  Parameters:
    `ramdisk` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setPVArgs

    public void setPVArgs(Connection c,
                          String args)
                   throws Types.BadServerResponse,
                          Types.XenAPIException,
                          org.apache.xmlrpc.XmlRpcException

  Set the PV/args field of the given VM.

  Parameters:
    `args` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setPVBootloaderArgs

    public void setPVBootloaderArgs(Connection c,
                                    String bootloaderArgs)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Set the PV/bootloader_args field of the given VM.

  Parameters:
    `bootloaderArgs` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setPVLegacyArgs

    public void setPVLegacyArgs(Connection c,
                                String legacyArgs)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException

  Set the PV/legacy_args field of the given VM.

  Parameters:
    `legacyArgs` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setHVMBootPolicy

    public void setHVMBootPolicy(Connection c,
                                 String bootPolicy)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException

  Set the HVM/boot_policy field of the given VM.

  Parameters:
    `bootPolicy` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setHVMBootParams

    public void setHVMBootParams(Connection c,
                                 Map<String,String> bootParams)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException

  Set the HVM/boot_params field of the given VM.

  Parameters:
    `bootParams` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### addToHVMBootParams

    public void addToHVMBootParams(Connection c,
                                   String key,
                                   String value)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Add the given key-value pair to the HVM/boot_params field of the given VM.

  Parameters:
    `key` - Key to add
    `value` - Value to add
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### removeFromHVMBootParams

    public void removeFromHVMBootParams(Connection c,
                                        String key)
                                 throws Types.BadServerResponse,
                                        Types.XenAPIException,
                                        org.apache.xmlrpc.XmlRpcException

  Remove the given key and its corresponding value from the HVM/boot_params field of the given VM. If the key is not in that Map, then do nothing.

  Parameters:
    `key` - Key to remove
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setPlatform

    public void setPlatform(Connection c,
                            Map<String,String> platform)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Set the platform field of the given VM.

  Parameters:
    `platform` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### addToPlatform

    public void addToPlatform(Connection c,
                              String key,
                              String value)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException

  Add the given key-value pair to the platform field of the given VM.

  Parameters:
    `key` - Key to add
    `value` - Value to add
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### removeFromPlatform

    public void removeFromPlatform(Connection c,
                                   String key)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Remove the given key and its corresponding value from the platform field of the given VM. If the key is not in that Map, then do nothing.

  Parameters:
    `key` - Key to remove
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setPCIBus

    @Deprecated
    public void setPCIBus(Connection c,
                                     String PCIBus)
                   throws Types.BadServerResponse,
                          Types.XenAPIException,
                          org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Set the PCI_bus field of the given VM.

  Parameters:
    `PCIBus` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setOtherConfig

    public void setOtherConfig(Connection c,
                               Map<String,String> otherConfig)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Set the other_config field of the given VM.

  Parameters:
    `otherConfig` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### addToOtherConfig

    public void addToOtherConfig(Connection c,
                                 String key,
                                 String value)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException

  Add the given key-value pair to the other_config field of the given VM.

  Parameters:
    `key` - Key to add
    `value` - Value to add
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### removeFromOtherConfig

    public void removeFromOtherConfig(Connection c,
                                      String key)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Remove the given key and its corresponding value from the other_config field of the given VM. If the key is not in that Map, then do nothing.

  Parameters:
    `key` - Key to remove
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setRecommendations

    public void setRecommendations(Connection c,
                                   String recommendations)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Set the recommendations field of the given VM.

  Parameters:
    `recommendations` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setXenstoreData

    public void setXenstoreData(Connection c,
                                Map<String,String> xenstoreData)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException

  Set the xenstore_data field of the given VM.

  Parameters:
    `xenstoreData` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### addToXenstoreData

    public void addToXenstoreData(Connection c,
                                  String key,
                                  String value)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Add the given key-value pair to the xenstore_data field of the given VM.

  Parameters:
    `key` - Key to add
    `value` - Value to add
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### removeFromXenstoreData

    public void removeFromXenstoreData(Connection c,
                                       String key)
                                throws Types.BadServerResponse,
                                       Types.XenAPIException,
                                       org.apache.xmlrpc.XmlRpcException

  Remove the given key and its corresponding value from the xenstore_data field of the given VM. If the key is not in that Map, then do nothing.

  Parameters:
    `key` - Key to remove
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setTags

    public void setTags(Connection c,
                        Set<String> tags)
                 throws Types.BadServerResponse,
                        Types.XenAPIException,
                        org.apache.xmlrpc.XmlRpcException

  Set the tags field of the given VM.

  Parameters:
    `tags` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### addTags

    public void addTags(Connection c,
                        String value)
                 throws Types.BadServerResponse,
                        Types.XenAPIException,
                        org.apache.xmlrpc.XmlRpcException

  Add the given value to the tags field of the given VM. If the value is already in that Set, then do nothing.

  Parameters:
    `value` - New value to add
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### removeTags

    public void removeTags(Connection c,
                           String value)
                    throws Types.BadServerResponse,
                           Types.XenAPIException,
                           org.apache.xmlrpc.XmlRpcException

  Remove the given value from the tags field of the given VM. If the value is not in that Set, then do nothing.

  Parameters:
    `value` - Value to remove
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setBlockedOperations

    public void setBlockedOperations(Connection c,
                                     Map<Types.VmOperations,String> blockedOperations)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Set the blocked_operations field of the given VM.

  Parameters:
    `blockedOperations` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### addToBlockedOperations

    public void addToBlockedOperations(Connection c,
                                       Types.VmOperations key,
                                       String value)
                                throws Types.BadServerResponse,
                                       Types.XenAPIException,
                                       org.apache.xmlrpc.XmlRpcException

  Add the given key-value pair to the blocked_operations field of the given VM.

  Parameters:
    `key` - Key to add
    `value` - Value to add
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### removeFromBlockedOperations

    public void removeFromBlockedOperations(Connection c,
                                            Types.VmOperations key)
                                     throws Types.BadServerResponse,
                                            Types.XenAPIException,
                                            org.apache.xmlrpc.XmlRpcException

  Remove the given key and its corresponding value from the blocked_operations field of the given VM. If the key is not in that Map, then do nothing.

  Parameters:
    `key` - Key to remove
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setSuspendSR

    public void setSuspendSR(Connection c,
                             SR suspendSR)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException

  Set the suspend_SR field of the given VM.

  Parameters:
    `suspendSR` - New value to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### snapshotAsync

    public Task snapshotAsync(Connection c,
                              String newName)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException,
                              Types.VmBadPowerState,
                              Types.SrFull,
                              Types.OperationNotAllowed

  Snapshots the specified VM, making a new VM. Snapshot automatically exploits the capabilities of the underlying storage repository in which the VM's disk images are stored (e.g. Copy on Write).

  Parameters:
    `newName` - The name of the snapshotted VM
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`

### snapshot

    public VM snapshot(Connection c,
                       String newName)
                throws Types.BadServerResponse,
                       Types.XenAPIException,
                       org.apache.xmlrpc.XmlRpcException,
                       Types.VmBadPowerState,
                       Types.SrFull,
                       Types.OperationNotAllowed

  Snapshots the specified VM, making a new VM. Snapshot automatically exploits the capabilities of the underlying storage repository in which the VM's disk images are stored (e.g. Copy on Write).

  Parameters:
    `newName` - The name of the snapshotted VM
  Returns:
    The reference of the newly created VM.
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`

### snapshotWithQuiesceAsync

    public Task snapshotWithQuiesceAsync(Connection c,
                                         String newName)
                                  throws Types.BadServerResponse,
                                         Types.XenAPIException,
                                         org.apache.xmlrpc.XmlRpcException,
                                         Types.VmBadPowerState,
                                         Types.SrFull,
                                         Types.OperationNotAllowed,
                                         Types.VmSnapshotWithQuiesceFailed,
                                         Types.VmSnapshotWithQuiesceTimeout,
                                         Types.VmSnapshotWithQuiescePluginDeosNotRespond,
                                         Types.VmSnapshotWithQuiesceNotSupported

  Snapshots the specified VM with quiesce, making a new VM. Snapshot automatically exploits the capabilities of the underlying storage repository in which the VM's disk images are stored (e.g. Copy on Write).

  Parameters:
    `newName` - The name of the snapshotted VM
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`
    `Types.VmSnapshotWithQuiesceFailed`
    `Types.VmSnapshotWithQuiesceTimeout`
    `Types.VmSnapshotWithQuiescePluginDeosNotRespond`
    `Types.VmSnapshotWithQuiesceNotSupported`

### snapshotWithQuiesce

    public VM snapshotWithQuiesce(Connection c,
                                  String newName)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException,
                                  Types.VmBadPowerState,
                                  Types.SrFull,
                                  Types.OperationNotAllowed,
                                  Types.VmSnapshotWithQuiesceFailed,
                                  Types.VmSnapshotWithQuiesceTimeout,
                                  Types.VmSnapshotWithQuiescePluginDeosNotRespond,
                                  Types.VmSnapshotWithQuiesceNotSupported

  Snapshots the specified VM with quiesce, making a new VM. Snapshot automatically exploits the capabilities of the underlying storage repository in which the VM's disk images are stored (e.g. Copy on Write).

  Parameters:
    `newName` - The name of the snapshotted VM
  Returns:
    The reference of the newly created VM.
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`
    `Types.VmSnapshotWithQuiesceFailed`
    `Types.VmSnapshotWithQuiesceTimeout`
    `Types.VmSnapshotWithQuiescePluginDeosNotRespond`
    `Types.VmSnapshotWithQuiesceNotSupported`

### createCloneAsync

    public Task createCloneAsync(Connection c,
                                 String newName)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException,
                                 Types.VmBadPowerState,
                                 Types.SrFull,
                                 Types.OperationNotAllowed

  Clones the specified VM, making a new VM. Clone automatically exploits the capabilities of the underlying storage repository in which the VM's disk images are stored (e.g. Copy on Write). This function can only be called when the VM is in the Halted State.

  Parameters:
    `newName` - The name of the cloned VM
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`

### createClone

    public VM createClone(Connection c,
                          String newName)
                   throws Types.BadServerResponse,
                          Types.XenAPIException,
                          org.apache.xmlrpc.XmlRpcException,
                          Types.VmBadPowerState,
                          Types.SrFull,
                          Types.OperationNotAllowed

  Clones the specified VM, making a new VM. Clone automatically exploits the capabilities of the underlying storage repository in which the VM's disk images are stored (e.g. Copy on Write). This function can only be called when the VM is in the Halted State.

  Parameters:
    `newName` - The name of the cloned VM
  Returns:
    The reference of the newly created VM.
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`

### copyAsync

    public Task copyAsync(Connection c,
                          String newName,
                          SR sr)
                   throws Types.BadServerResponse,
                          Types.XenAPIException,
                          org.apache.xmlrpc.XmlRpcException,
                          Types.VmBadPowerState,
                          Types.SrFull,
                          Types.OperationNotAllowed

  Copied the specified VM, making a new VM. Unlike clone, copy does not exploits the capabilities of the underlying storage repository in which the VM's disk images are stored. Instead, copy guarantees that the disk images of the newly created VM will be 'full disks' - i.e. not part of a CoW chain. This function can only be called when the VM is in the Halted State.

  Parameters:
    `newName` - The name of the copied VM
    `sr` - An SR to copy all the VM's disks into (if an invalid reference then it uses the existing SRs)
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`

### copy

    public VM copy(Connection c,
                   String newName,
                   SR sr)
            throws Types.BadServerResponse,
                   Types.XenAPIException,
                   org.apache.xmlrpc.XmlRpcException,
                   Types.VmBadPowerState,
                   Types.SrFull,
                   Types.OperationNotAllowed

  Copied the specified VM, making a new VM. Unlike clone, copy does not exploits the capabilities of the underlying storage repository in which the VM's disk images are stored. Instead, copy guarantees that the disk images of the newly created VM will be 'full disks' - i.e. not part of a CoW chain. This function can only be called when the VM is in the Halted State.

  Parameters:
    `newName` - The name of the copied VM
    `sr` - An SR to copy all the VM's disks into (if an invalid reference then it uses the existing SRs)
  Returns:
    The reference of the newly created VM.
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`

### revertAsync

    public Task revertAsync(Connection c)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException,
                            Types.VmBadPowerState,
                            Types.OperationNotAllowed,
                            Types.SrFull,
                            Types.VmRevertFailed

  Reverts the specified VM to a previous state.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OperationNotAllowed`
    `Types.SrFull`
    `Types.VmRevertFailed`

### revert

    public void revert(Connection c)
                throws Types.BadServerResponse,
                       Types.XenAPIException,
                       org.apache.xmlrpc.XmlRpcException,
                       Types.VmBadPowerState,
                       Types.OperationNotAllowed,
                       Types.SrFull,
                       Types.VmRevertFailed

  Reverts the specified VM to a previous state.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OperationNotAllowed`
    `Types.SrFull`
    `Types.VmRevertFailed`

### checkpointAsync

    public Task checkpointAsync(Connection c,
                                String newName)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException,
                                Types.VmBadPowerState,
                                Types.SrFull,
                                Types.OperationNotAllowed,
                                Types.VmCheckpointSuspendFailed,
                                Types.VmCheckpointResumeFailed

  Checkpoints the specified VM, making a new VM. Checkpoint automatically exploits the capabilities of the underlying storage repository in which the VM's disk images are stored (e.g. Copy on Write) and saves the memory image as well.

  Parameters:
    `newName` - The name of the checkpointed VM
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`
    `Types.VmCheckpointSuspendFailed`
    `Types.VmCheckpointResumeFailed`

### checkpoint

    public VM checkpoint(Connection c,
                         String newName)
                  throws Types.BadServerResponse,
                         Types.XenAPIException,
                         org.apache.xmlrpc.XmlRpcException,
                         Types.VmBadPowerState,
                         Types.SrFull,
                         Types.OperationNotAllowed,
                         Types.VmCheckpointSuspendFailed,
                         Types.VmCheckpointResumeFailed

  Checkpoints the specified VM, making a new VM. Checkpoint automatically exploits the capabilities of the underlying storage repository in which the VM's disk images are stored (e.g. Copy on Write) and saves the memory image as well.

  Parameters:
    `newName` - The name of the checkpointed VM
  Returns:
    The reference of the newly created VM.
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`
    `Types.VmCheckpointSuspendFailed`
    `Types.VmCheckpointResumeFailed`

### provisionAsync

    public Task provisionAsync(Connection c)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException,
                               Types.VmBadPowerState,
                               Types.SrFull,
                               Types.OperationNotAllowed

  Inspects the disk configuration contained within the VM's other_config, creates VDIs and VBDs and then executes any applicable post-install script.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`

### provision

    public void provision(Connection c)
                   throws Types.BadServerResponse,
                          Types.XenAPIException,
                          org.apache.xmlrpc.XmlRpcException,
                          Types.VmBadPowerState,
                          Types.SrFull,
                          Types.OperationNotAllowed

  Inspects the disk configuration contained within the VM's other_config, creates VDIs and VBDs and then executes any applicable post-install script.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.SrFull`
    `Types.OperationNotAllowed`

### startAsync

    public Task startAsync(Connection c,
                           Boolean startPaused,
                           Boolean force)
                    throws Types.BadServerResponse,
                           Types.XenAPIException,
                           org.apache.xmlrpc.XmlRpcException,
                           Types.VmBadPowerState,
                           Types.VmHvmRequired,
                           Types.VmIsTemplate,
                           Types.OtherOperationInProgress,
                           Types.OperationNotAllowed,
                           Types.BootloaderFailed,
                           Types.UnknownBootloader,
                           Types.NoHostsAvailable,
                           Types.LicenceRestriction

  Start the specified VM. This function can only be called with the VM is in the Halted State.

  Parameters:
    `startPaused` - Instantiate VM in paused state if set to true.
    `force` - Attempt to force the VM to start. If this flag is false then the VM may fail pre-boot safety checks (e.g. if the CPU the VM last booted on looks substantially different to the current one)
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.VmHvmRequired`
    `Types.VmIsTemplate`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.BootloaderFailed`
    `Types.UnknownBootloader`
    `Types.NoHostsAvailable`
    `Types.LicenceRestriction`

### start

    public void start(Connection c,
                      Boolean startPaused,
                      Boolean force)
               throws Types.BadServerResponse,
                      Types.XenAPIException,
                      org.apache.xmlrpc.XmlRpcException,
                      Types.VmBadPowerState,
                      Types.VmHvmRequired,
                      Types.VmIsTemplate,
                      Types.OtherOperationInProgress,
                      Types.OperationNotAllowed,
                      Types.BootloaderFailed,
                      Types.UnknownBootloader,
                      Types.NoHostsAvailable,
                      Types.LicenceRestriction

  Start the specified VM. This function can only be called with the VM is in the Halted State.

  Parameters:
    `startPaused` - Instantiate VM in paused state if set to true.
    `force` - Attempt to force the VM to start. If this flag is false then the VM may fail pre-boot safety checks (e.g. if the CPU the VM last booted on looks substantially different to the current one)
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.VmHvmRequired`
    `Types.VmIsTemplate`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.BootloaderFailed`
    `Types.UnknownBootloader`
    `Types.NoHostsAvailable`
    `Types.LicenceRestriction`

### startOnAsync

    public Task startOnAsync(Connection c,
                             Host host,
                             Boolean startPaused,
                             Boolean force)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException,
                             Types.VmBadPowerState,
                             Types.VmIsTemplate,
                             Types.OtherOperationInProgress,
                             Types.OperationNotAllowed,
                             Types.BootloaderFailed,
                             Types.UnknownBootloader

  Start the specified VM on a particular host. This function can only be called with the VM is in the Halted State.

  Parameters:
    `host` - The Host on which to start the VM
    `startPaused` - Instantiate VM in paused state if set to true.
    `force` - Attempt to force the VM to start. If this flag is false then the VM may fail pre-boot safety checks (e.g. if the CPU the VM last booted on looks substantially different to the current one)
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.VmIsTemplate`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.BootloaderFailed`
    `Types.UnknownBootloader`

### startOn

    public void startOn(Connection c,
                        Host host,
                        Boolean startPaused,
                        Boolean force)
                 throws Types.BadServerResponse,
                        Types.XenAPIException,
                        org.apache.xmlrpc.XmlRpcException,
                        Types.VmBadPowerState,
                        Types.VmIsTemplate,
                        Types.OtherOperationInProgress,
                        Types.OperationNotAllowed,
                        Types.BootloaderFailed,
                        Types.UnknownBootloader

  Start the specified VM on a particular host. This function can only be called with the VM is in the Halted State.

  Parameters:
    `host` - The Host on which to start the VM
    `startPaused` - Instantiate VM in paused state if set to true.
    `force` - Attempt to force the VM to start. If this flag is false then the VM may fail pre-boot safety checks (e.g. if the CPU the VM last booted on looks substantially different to the current one)
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.VmIsTemplate`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.BootloaderFailed`
    `Types.UnknownBootloader`

### pauseAsync

    public Task pauseAsync(Connection c)
                    throws Types.BadServerResponse,
                           Types.XenAPIException,
                           org.apache.xmlrpc.XmlRpcException,
                           Types.VmBadPowerState,
                           Types.OtherOperationInProgress,
                           Types.OperationNotAllowed,
                           Types.VmIsTemplate

  Pause the specified VM. This can only be called when the specified VM is in the Running state.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### pause

    public void pause(Connection c)
               throws Types.BadServerResponse,
                      Types.XenAPIException,
                      org.apache.xmlrpc.XmlRpcException,
                      Types.VmBadPowerState,
                      Types.OtherOperationInProgress,
                      Types.OperationNotAllowed,
                      Types.VmIsTemplate

  Pause the specified VM. This can only be called when the specified VM is in the Running state.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### unpauseAsync

    public Task unpauseAsync(Connection c)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException,
                             Types.VmBadPowerState,
                             Types.OperationNotAllowed,
                             Types.VmIsTemplate

  Resume the specified VM. This can only be called when the specified VM is in the Paused state.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### unpause

    public void unpause(Connection c)
                 throws Types.BadServerResponse,
                        Types.XenAPIException,
                        org.apache.xmlrpc.XmlRpcException,
                        Types.VmBadPowerState,
                        Types.OperationNotAllowed,
                        Types.VmIsTemplate

  Resume the specified VM. This can only be called when the specified VM is in the Paused state.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### cleanShutdownAsync

    public Task cleanShutdownAsync(Connection c)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException,
                                   Types.VmBadPowerState,
                                   Types.OtherOperationInProgress,
                                   Types.OperationNotAllowed,
                                   Types.VmIsTemplate

  Attempt to cleanly shutdown the specified VM. (Note: this may not be supported---e.g. if a guest agent is not installed). This can only be called when the specified VM is in the Running state.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### cleanShutdown

    public void cleanShutdown(Connection c)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException,
                              Types.VmBadPowerState,
                              Types.OtherOperationInProgress,
                              Types.OperationNotAllowed,
                              Types.VmIsTemplate

  Attempt to cleanly shutdown the specified VM. (Note: this may not be supported---e.g. if a guest agent is not installed). This can only be called when the specified VM is in the Running state.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### shutdownAsync

    public Task shutdownAsync(Connection c)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException,
                              Types.VmBadPowerState,
                              Types.OtherOperationInProgress,
                              Types.OperationNotAllowed,
                              Types.VmIsTemplate

  Attempts to first clean shutdown a VM and if it should fail then perform a hard shutdown on it.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### shutdown

    public void shutdown(Connection c)
                  throws Types.BadServerResponse,
                         Types.XenAPIException,
                         org.apache.xmlrpc.XmlRpcException,
                         Types.VmBadPowerState,
                         Types.OtherOperationInProgress,
                         Types.OperationNotAllowed,
                         Types.VmIsTemplate

  Attempts to first clean shutdown a VM and if it should fail then perform a hard shutdown on it.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### cleanRebootAsync

    public Task cleanRebootAsync(Connection c)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException,
                                 Types.VmBadPowerState,
                                 Types.OtherOperationInProgress,
                                 Types.OperationNotAllowed,
                                 Types.VmIsTemplate

  Attempt to cleanly shutdown the specified VM (Note: this may not be supported---e.g. if a guest agent is not installed). This can only be called when the specified VM is in the Running state.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### cleanReboot

    public void cleanReboot(Connection c)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException,
                            Types.VmBadPowerState,
                            Types.OtherOperationInProgress,
                            Types.OperationNotAllowed,
                            Types.VmIsTemplate

  Attempt to cleanly shutdown the specified VM (Note: this may not be supported---e.g. if a guest agent is not installed). This can only be called when the specified VM is in the Running state.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### hardShutdownAsync

    public Task hardShutdownAsync(Connection c)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException,
                                  Types.VmBadPowerState,
                                  Types.OtherOperationInProgress,
                                  Types.OperationNotAllowed,
                                  Types.VmIsTemplate

  Stop executing the specified VM without attempting a clean shutdown.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### hardShutdown

    public void hardShutdown(Connection c)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException,
                             Types.VmBadPowerState,
                             Types.OtherOperationInProgress,
                             Types.OperationNotAllowed,
                             Types.VmIsTemplate

  Stop executing the specified VM without attempting a clean shutdown.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### powerStateResetAsync

    public Task powerStateResetAsync(Connection c)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Reset the power-state of the VM to halted in the database only. (Used to recover from slave failures in pooling scenarios by resetting the power-states of VMs running on dead slaves to halted.) This is a potentially dangerous operation; use with care.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### powerStateReset

    public void powerStateReset(Connection c)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException

  Reset the power-state of the VM to halted in the database only. (Used to recover from slave failures in pooling scenarios by resetting the power-states of VMs running on dead slaves to halted.) This is a potentially dangerous operation; use with care.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### hardRebootAsync

    public Task hardRebootAsync(Connection c)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException,
                                Types.VmBadPowerState,
                                Types.OtherOperationInProgress,
                                Types.OperationNotAllowed,
                                Types.VmIsTemplate

  Stop executing the specified VM without attempting a clean shutdown and immediately restart the VM.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### hardReboot

    public void hardReboot(Connection c)
                    throws Types.BadServerResponse,
                           Types.XenAPIException,
                           org.apache.xmlrpc.XmlRpcException,
                           Types.VmBadPowerState,
                           Types.OtherOperationInProgress,
                           Types.OperationNotAllowed,
                           Types.VmIsTemplate

  Stop executing the specified VM without attempting a clean shutdown and immediately restart the VM.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### suspendAsync

    public Task suspendAsync(Connection c)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException,
                             Types.VmBadPowerState,
                             Types.OtherOperationInProgress,
                             Types.OperationNotAllowed,
                             Types.VmIsTemplate

  Suspend the specified VM to disk. This can only be called when the specified VM is in the Running state.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### suspend

    public void suspend(Connection c)
                 throws Types.BadServerResponse,
                        Types.XenAPIException,
                        org.apache.xmlrpc.XmlRpcException,
                        Types.VmBadPowerState,
                        Types.OtherOperationInProgress,
                        Types.OperationNotAllowed,
                        Types.VmIsTemplate

  Suspend the specified VM to disk. This can only be called when the specified VM is in the Running state.

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### resumeAsync

    public Task resumeAsync(Connection c,
                            Boolean startPaused,
                            Boolean force)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException,
                            Types.VmBadPowerState,
                            Types.OperationNotAllowed,
                            Types.VmIsTemplate

  Awaken the specified VM and resume it. This can only be called when the specified VM is in the Suspended state.

  Parameters:
    `startPaused` - Resume VM in paused state if set to true.
    `force` - Attempt to force the VM to resume. If this flag is false then the VM may fail pre-resume safety checks (e.g. if the CPU the VM was running on looks substantially different to the current one)
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### resume

    public void resume(Connection c,
                       Boolean startPaused,
                       Boolean force)
                throws Types.BadServerResponse,
                       Types.XenAPIException,
                       org.apache.xmlrpc.XmlRpcException,
                       Types.VmBadPowerState,
                       Types.OperationNotAllowed,
                       Types.VmIsTemplate

  Awaken the specified VM and resume it. This can only be called when the specified VM is in the Suspended state.

  Parameters:
    `startPaused` - Resume VM in paused state if set to true.
    `force` - Attempt to force the VM to resume. If this flag is false then the VM may fail pre-resume safety checks (e.g. if the CPU the VM was running on looks substantially different to the current one)
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### resumeOnAsync

    public Task resumeOnAsync(Connection c,
                              Host host,
                              Boolean startPaused,
                              Boolean force)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException,
                              Types.VmBadPowerState,
                              Types.OperationNotAllowed,
                              Types.VmIsTemplate

  Awaken the specified VM and resume it on a particular Host. This can only be called when the specified VM is in the Suspended state.

  Parameters:
    `host` - The Host on which to resume the VM
    `startPaused` - Resume VM in paused state if set to true.
    `force` - Attempt to force the VM to resume. If this flag is false then the VM may fail pre-resume safety checks (e.g. if the CPU the VM was running on looks substantially different to the current one)
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### resumeOn

    public void resumeOn(Connection c,
                         Host host,
                         Boolean startPaused,
                         Boolean force)
                  throws Types.BadServerResponse,
                         Types.XenAPIException,
                         org.apache.xmlrpc.XmlRpcException,
                         Types.VmBadPowerState,
                         Types.OperationNotAllowed,
                         Types.VmIsTemplate

  Awaken the specified VM and resume it on a particular Host. This can only be called when the specified VM is in the Suspended state.

  Parameters:
    `host` - The Host on which to resume the VM
    `startPaused` - Resume VM in paused state if set to true.
    `force` - Attempt to force the VM to resume. If this flag is false then the VM may fail pre-resume safety checks (e.g. if the CPU the VM was running on looks substantially different to the current one)
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OperationNotAllowed`
    `Types.VmIsTemplate`

### poolMigrateAsync

    public Task poolMigrateAsync(Connection c,
                                 Host host,
                                 Map<String,String> options)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException,
                                 Types.VmBadPowerState,
                                 Types.OtherOperationInProgress,
                                 Types.VmIsTemplate,
                                 Types.OperationNotAllowed,
                                 Types.VmMigrateFailed,
                                 Types.VmMissingPvDrivers

  Migrate a VM to another Host. This can only be called when the specified VM is in the Running state.

  Parameters:
    `host` - The target host
    `options` - Extra configuration operations
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.VmIsTemplate`
    `Types.OperationNotAllowed`
    `Types.VmMigrateFailed`
    `Types.VmMissingPvDrivers`

### poolMigrate

    public void poolMigrate(Connection c,
                            Host host,
                            Map<String,String> options)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException,
                            Types.VmBadPowerState,
                            Types.OtherOperationInProgress,
                            Types.VmIsTemplate,
                            Types.OperationNotAllowed,
                            Types.VmMigrateFailed,
                            Types.VmMissingPvDrivers

  Migrate a VM to another Host. This can only be called when the specified VM is in the Running state.

  Parameters:
    `host` - The target host
    `options` - Extra configuration operations
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`
    `Types.OtherOperationInProgress`
    `Types.VmIsTemplate`
    `Types.OperationNotAllowed`
    `Types.VmMigrateFailed`
    `Types.VmMissingPvDrivers`

### setVCPUsNumberLiveAsync

    public Task setVCPUsNumberLiveAsync(Connection c,
                                        Long nvcpu)
                                 throws Types.BadServerResponse,
                                        Types.XenAPIException,
                                        org.apache.xmlrpc.XmlRpcException

  Set the number of VCPUs for a running VM

  Parameters:
    `nvcpu` - The number of VCPUs
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setVCPUsNumberLive

    public void setVCPUsNumberLive(Connection c,
                                   Long nvcpu)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Set the number of VCPUs for a running VM

  Parameters:
    `nvcpu` - The number of VCPUs
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### addToVCPUsParamsLiveAsync

    public Task addToVCPUsParamsLiveAsync(Connection c,
                                          String key,
                                          String value)
                                   throws Types.BadServerResponse,
                                          Types.XenAPIException,
                                          org.apache.xmlrpc.XmlRpcException

  Add the given key-value pair to VM.VCPUs_params, and apply that value on the running VM

  Parameters:
    `key` - The key
    `value` - The value
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### addToVCPUsParamsLive

    public void addToVCPUsParamsLive(Connection c,
                                     String key,
                                     String value)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Add the given key-value pair to VM.VCPUs_params, and apply that value on the running VM

  Parameters:
    `key` - The key
    `value` - The value
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setHaRestartPriority

    public void setHaRestartPriority(Connection c,
                                     String value)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Set the value of the ha_restart_priority field

  Parameters:
    `value` - The value
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setHaAlwaysRun

    @Deprecated
    public void setHaAlwaysRun(Connection c,
                                          Boolean value)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Set the value of the ha_always_run

  Parameters:
    `value` - The value
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### computeMemoryOverheadAsync

    public Task computeMemoryOverheadAsync(Connection c)
                                    throws Types.BadServerResponse,
                                           Types.XenAPIException,
                                           org.apache.xmlrpc.XmlRpcException

  Computes the virtualization memory overhead of a VM.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### computeMemoryOverhead

    public Long computeMemoryOverhead(Connection c)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Computes the virtualization memory overhead of a VM.

  Returns:
    the virtualization memory overhead of the VM.
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryDynamicMax

    public void setMemoryDynamicMax(Connection c,
                                    Long value)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Set the value of the memory_dynamic_max field

  Parameters:
    `value` - The new value of memory_dynamic_max
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryDynamicMin

    public void setMemoryDynamicMin(Connection c,
                                    Long value)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Set the value of the memory_dynamic_min field

  Parameters:
    `value` - The new value of memory_dynamic_min
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryDynamicRangeAsync

    public Task setMemoryDynamicRangeAsync(Connection c,
                                           Long min,
                                           Long max)
                                    throws Types.BadServerResponse,
                                           Types.XenAPIException,
                                           org.apache.xmlrpc.XmlRpcException

  Set the minimum and maximum amounts of physical memory the VM is allowed to use.

  Parameters:
    `min` - The new minimum value
    `max` - The new maximum value
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryDynamicRange

    public void setMemoryDynamicRange(Connection c,
                                      Long min,
                                      Long max)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Set the minimum and maximum amounts of physical memory the VM is allowed to use.

  Parameters:
    `min` - The new minimum value
    `max` - The new maximum value
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryStaticMax

    public void setMemoryStaticMax(Connection c,
                                   Long value)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException,
                                   Types.HaOperationWouldBreakFailoverPlan

  Set the value of the memory_static_max field

  Parameters:
    `value` - The new value of memory_static_max
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.HaOperationWouldBreakFailoverPlan`

### setMemoryStaticMin

    public void setMemoryStaticMin(Connection c,
                                   Long value)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Set the value of the memory_static_min field

  Parameters:
    `value` - The new value of memory_static_min
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryStaticRangeAsync

    public Task setMemoryStaticRangeAsync(Connection c,
                                          Long min,
                                          Long max)
                                   throws Types.BadServerResponse,
                                          Types.XenAPIException,
                                          org.apache.xmlrpc.XmlRpcException

  Set the static (ie boot-time) range of virtual memory that the VM is allowed to use.

  Parameters:
    `min` - The new minimum value
    `max` - The new maximum value
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryStaticRange

    public void setMemoryStaticRange(Connection c,
                                     Long min,
                                     Long max)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Set the static (ie boot-time) range of virtual memory that the VM is allowed to use.

  Parameters:
    `min` - The new minimum value
    `max` - The new maximum value
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryLimitsAsync

    public Task setMemoryLimitsAsync(Connection c,
                                     Long staticMin,
                                     Long staticMax,
                                     Long dynamicMin,
                                     Long dynamicMax)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Set the memory limits of this VM.

  Parameters:
    `staticMin` - The new value of memory_static_min.
    `staticMax` - The new value of memory_static_max.
    `dynamicMin` - The new value of memory_dynamic_min.
    `dynamicMax` - The new value of memory_dynamic_max.
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryLimits

    public void setMemoryLimits(Connection c,
                                Long staticMin,
                                Long staticMax,
                                Long dynamicMin,
                                Long dynamicMax)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException

  Set the memory limits of this VM.

  Parameters:
    `staticMin` - The new value of memory_static_min.
    `staticMax` - The new value of memory_static_max.
    `dynamicMin` - The new value of memory_dynamic_min.
    `dynamicMax` - The new value of memory_dynamic_max.
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryTargetLiveAsync

    @Deprecated
    public Task setMemoryTargetLiveAsync(Connection c,
                                                    Long target)
                                  throws Types.BadServerResponse,
                                         Types.XenAPIException,
                                         org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Set the memory target for a running VM

  Parameters:
    `target` - The target in bytes
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setMemoryTargetLive

    @Deprecated
    public void setMemoryTargetLive(Connection c,
                                               Long target)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Set the memory target for a running VM

  Parameters:
    `target` - The target in bytes
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### waitMemoryTargetLiveAsync

    @Deprecated
    public Task waitMemoryTargetLiveAsync(Connection c)
                                   throws Types.BadServerResponse,
                                          Types.XenAPIException,
                                          org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Wait for a running VM to reach its current memory target

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### waitMemoryTargetLive

    @Deprecated
    public void waitMemoryTargetLive(Connection c)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Wait for a running VM to reach its current memory target

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getCooperativeAsync

    @Deprecated
    public Task getCooperativeAsync(Connection c)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Return true if the VM is currently 'co-operative' i.e. is expected to reach a balloon target and actually has done

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getCooperative

    @Deprecated
    public Boolean getCooperative(Connection c)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Deprecated.

  Return true if the VM is currently 'co-operative' i.e. is expected to reach a balloon target and actually has done

  Returns:
    true if the VM is currently 'co-operative'; false otherwise
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setHVMShadowMultiplier

    public void setHVMShadowMultiplier(Connection c,
                                       Double value)
                                throws Types.BadServerResponse,
                                       Types.XenAPIException,
                                       org.apache.xmlrpc.XmlRpcException

  Set the shadow memory multiplier on a halted VM

  Parameters:
    `value` - The new shadow memory multiplier to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setShadowMultiplierLiveAsync

    public Task setShadowMultiplierLiveAsync(Connection c,
                                             Double multiplier)
                                      throws Types.BadServerResponse,
                                             Types.XenAPIException,
                                             org.apache.xmlrpc.XmlRpcException

  Set the shadow memory multiplier on a running VM

  Parameters:
    `multiplier` - The new shadow memory multiplier to set
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setShadowMultiplierLive

    public void setShadowMultiplierLive(Connection c,
                                        Double multiplier)
                                 throws Types.BadServerResponse,
                                        Types.XenAPIException,
                                        org.apache.xmlrpc.XmlRpcException

  Set the shadow memory multiplier on a running VM

  Parameters:
    `multiplier` - The new shadow memory multiplier to set
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setVCPUsMax

    public void setVCPUsMax(Connection c,
                            Long value)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Set the maximum number of VCPUs for a halted VM

  Parameters:
    `value` - The new maximum number of VCPUs
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setVCPUsAtStartup

    public void setVCPUsAtStartup(Connection c,
                                  Long value)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Set the number of startup VCPUs for a halted VM

  Parameters:
    `value` - The new maximum number of VCPUs
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### sendSysrqAsync

    public Task sendSysrqAsync(Connection c,
                               String key)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException,
                               Types.VmBadPowerState

  Send the given key as a sysrq to this VM. The key is specified as a single character (a String of length 1). This can only be called when the specified VM is in the Running state.

  Parameters:
    `key` - The key to send
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`

### sendSysrq

    public void sendSysrq(Connection c,
                          String key)
                   throws Types.BadServerResponse,
                          Types.XenAPIException,
                          org.apache.xmlrpc.XmlRpcException,
                          Types.VmBadPowerState

  Send the given key as a sysrq to this VM. The key is specified as a single character (a String of length 1). This can only be called when the specified VM is in the Running state.

  Parameters:
    `key` - The key to send
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`

### sendTriggerAsync

    public Task sendTriggerAsync(Connection c,
                                 String trigger)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException,
                                 Types.VmBadPowerState

  Send the named trigger to this VM. This can only be called when the specified VM is in the Running state.

  Parameters:
    `trigger` - The trigger to send
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`

### sendTrigger

    public void sendTrigger(Connection c,
                            String trigger)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException,
                            Types.VmBadPowerState

  Send the named trigger to this VM. This can only be called when the specified VM is in the Running state.

  Parameters:
    `trigger` - The trigger to send
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`

### maximiseMemoryAsync

    public Task maximiseMemoryAsync(Connection c,
                                    Long total,
                                    Boolean approximate)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Returns the maximum amount of guest memory which will fit, together with overheads, in the supplied amount of physical memory. If 'exact' is true then an exact calculation is performed using the VM's current settings. If 'exact' is false then a more conservative approximation is used

  Parameters:
    `total` - Total amount of physical RAM to fit within
    `approximate` - If false the limit is calculated with the guest's current exact configuration. Otherwise a more approximate calculation is performed
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### maximiseMemory

    public Long maximiseMemory(Connection c,
                               Long total,
                               Boolean approximate)
                        throws Types.BadServerResponse,
                               Types.XenAPIException,
                               org.apache.xmlrpc.XmlRpcException

  Returns the maximum amount of guest memory which will fit, together with overheads, in the supplied amount of physical memory. If 'exact' is true then an exact calculation is performed using the VM's current settings. If 'exact' is false then a more conservative approximation is used

  Parameters:
    `total` - Total amount of physical RAM to fit within
    `approximate` - If false the limit is calculated with the guest's current exact configuration. Otherwise a more approximate calculation is performed
  Returns:
    The maximum possible static-max
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### migrateSendAsync

    public Task migrateSendAsync(Connection c,
                                 Map<String,String> dest,
                                 Boolean live,
                                 Map<VDI,SR> vdiMap,
                                 Map<VIF,Network> vifMap,
                                 Map<String,String> options)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException,
                                 Types.VmBadPowerState

  Migrate the VM to another host. This can only be called when the specified VM is in the Running state.

  Parameters:
    `dest` - The result of a Host.migrate_receive call.
    `live` - Live migration
    `vdiMap` - Map of source VDI to destination SR
    `vifMap` - Map of source VIF to destination network
    `options` - Other parameters
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`

### migrateSend

    public void migrateSend(Connection c,
                            Map<String,String> dest,
                            Boolean live,
                            Map<VDI,SR> vdiMap,
                            Map<VIF,Network> vifMap,
                            Map<String,String> options)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException,
                            Types.VmBadPowerState

  Migrate the VM to another host. This can only be called when the specified VM is in the Running state.

  Parameters:
    `dest` - The result of a Host.migrate_receive call.
    `live` - Live migration
    `vdiMap` - Map of source VDI to destination SR
    `vifMap` - Map of source VIF to destination network
    `options` - Other parameters
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmBadPowerState`

### assertCanMigrateAsync

    public Task assertCanMigrateAsync(Connection c,
                                      Map<String,String> dest,
                                      Boolean live,
                                      Map<VDI,SR> vdiMap,
                                      Map<VIF,Network> vifMap,
                                      Map<String,String> options)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Assert whether a VM can be migrated to the specified destination.

  Parameters:
    `dest` - The result of a VM.migrate_receive call.
    `live` - Live migration
    `vdiMap` - Map of source VDI to destination SR
    `vifMap` - Map of source VIF to destination network
    `options` - Other parameters
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### assertCanMigrate

    public void assertCanMigrate(Connection c,
                                 Map<String,String> dest,
                                 Boolean live,
                                 Map<VDI,SR> vdiMap,
                                 Map<VIF,Network> vifMap,
                                 Map<String,String> options)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException

  Assert whether a VM can be migrated to the specified destination.

  Parameters:
    `dest` - The result of a VM.migrate_receive call.
    `live` - Live migration
    `vdiMap` - Map of source VDI to destination SR
    `vifMap` - Map of source VIF to destination network
    `options` - Other parameters
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getBootRecord

    public VM.Record getBootRecord(Connection c)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Returns a record describing the VM's dynamic state, initialised when the VM boots and updated to reflect runtime configuration changes e.g. CPU hotplug

  Returns:
    A record describing the VM
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getDataSources

    public Set<DataSource.Record> getDataSources(Connection c)
                                          throws Types.BadServerResponse,
                                                 Types.XenAPIException,
                                                 org.apache.xmlrpc.XmlRpcException

  Returns:
    A set of data sources
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### recordDataSource

    public void recordDataSource(Connection c,
                                 String dataSource)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException

  Start recording the specified data source

  Parameters:
    `dataSource` - The data source to record
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### queryDataSource

    public Double queryDataSource(Connection c,
                                  String dataSource)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Query the latest value of the specified data source

  Parameters:
    `dataSource` - The data source to query
  Returns:
    The latest value, averaged over the last 5 seconds
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### forgetDataSourceArchives

    public void forgetDataSourceArchives(Connection c,
                                         String dataSource)
                                  throws Types.BadServerResponse,
                                         Types.XenAPIException,
                                         org.apache.xmlrpc.XmlRpcException

  Forget the recorded statistics related to the specified data source

  Parameters:
    `dataSource` - The data source whose archives are to be forgotten
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### assertOperationValidAsync

    public Task assertOperationValidAsync(Connection c,
                                          Types.VmOperations op)
                                   throws Types.BadServerResponse,
                                          Types.XenAPIException,
                                          org.apache.xmlrpc.XmlRpcException

  Check to see whether this operation is acceptable in the current state of the system, raising an error if the operation is invalid for some reason

  Parameters:
    `op` - proposed operation
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### assertOperationValid

    public void assertOperationValid(Connection c,
                                     Types.VmOperations op)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Check to see whether this operation is acceptable in the current state of the system, raising an error if the operation is invalid for some reason

  Parameters:
    `op` - proposed operation
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### updateAllowedOperationsAsync

    public Task updateAllowedOperationsAsync(Connection c)
                                      throws Types.BadServerResponse,
                                             Types.XenAPIException,
                                             org.apache.xmlrpc.XmlRpcException

  Recomputes the list of acceptable operations

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### updateAllowedOperations

    public void updateAllowedOperations(Connection c)
                                 throws Types.BadServerResponse,
                                        Types.XenAPIException,
                                        org.apache.xmlrpc.XmlRpcException

  Recomputes the list of acceptable operations

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getAllowedVBDDevices

    public Set<String> getAllowedVBDDevices(Connection c)
                                     throws Types.BadServerResponse,
                                            Types.XenAPIException,
                                            org.apache.xmlrpc.XmlRpcException

  Returns a list of the allowed values that a VBD device field can take

  Returns:
    The allowed values
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getAllowedVIFDevices

    public Set<String> getAllowedVIFDevices(Connection c)
                                     throws Types.BadServerResponse,
                                            Types.XenAPIException,
                                            org.apache.xmlrpc.XmlRpcException

  Returns a list of the allowed values that a VIF device field can take

  Returns:
    The allowed values
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPossibleHostsAsync

    public Task getPossibleHostsAsync(Connection c)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Return the list of hosts on which this VM may run.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getPossibleHosts

    public Set<Host> getPossibleHosts(Connection c)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Return the list of hosts on which this VM may run.

  Returns:
    The possible hosts
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### assertCanBootHereAsync

    public Task assertCanBootHereAsync(Connection c,
                                       Host host)
                                throws Types.BadServerResponse,
                                       Types.XenAPIException,
                                       org.apache.xmlrpc.XmlRpcException,
                                       Types.HostNotEnoughFreeMemory,
                                       Types.VmRequiresSr,
                                       Types.VmHostIncompatibleVersion

  Returns an error if the VM could not boot on this host for some reason

  Parameters:
    `host` - The host
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.HostNotEnoughFreeMemory`
    `Types.VmRequiresSr`
    `Types.VmHostIncompatibleVersion`

### assertCanBootHere

    public void assertCanBootHere(Connection c,
                                  Host host)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException,
                                  Types.HostNotEnoughFreeMemory,
                                  Types.VmRequiresSr,
                                  Types.VmHostIncompatibleVersion

  Returns an error if the VM could not boot on this host for some reason

  Parameters:
    `host` - The host
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.HostNotEnoughFreeMemory`
    `Types.VmRequiresSr`
    `Types.VmHostIncompatibleVersion`

### createNewBlobAsync

    public Task createNewBlobAsync(Connection c,
                                   String name,
                                   String mimeType,
                                   Boolean _public)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Create a placeholder for a named binary blob of data that is associated with this VM

  Parameters:
    `name` - The name associated with the blob
    `mimeType` - The mime type for the data. Empty string translates to application/octet-stream
    `_public` - True if the blob should be publicly available
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### createNewBlob

    public Blob createNewBlob(Connection c,
                              String name,
                              String mimeType,
                              Boolean _public)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException

  Create a placeholder for a named binary blob of data that is associated with this VM

  Parameters:
    `name` - The name associated with the blob
    `mimeType` - The mime type for the data. Empty string translates to application/octet-stream
    `_public` - True if the blob should be publicly available
  Returns:
    The reference of the blob, needed for populating its data
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### assertAgileAsync

    public Task assertAgileAsync(Connection c)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException

  Returns an error if the VM is not considered agile e.g. because it is tied to a resource local to a host

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### assertAgile

    public void assertAgile(Connection c)
                     throws Types.BadServerResponse,
                            Types.XenAPIException,
                            org.apache.xmlrpc.XmlRpcException

  Returns an error if the VM is not considered agile e.g. because it is tied to a resource local to a host

  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### retrieveWlbRecommendationsAsync

    public Task retrieveWlbRecommendationsAsync(Connection c)
                                         throws Types.BadServerResponse,
                                                Types.XenAPIException,
                                                org.apache.xmlrpc.XmlRpcException

  Returns mapping of hosts to ratings, indicating the suitability of starting the VM at that location according to wlb. Rating is replaced with an error if the VM cannot boot there.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### retrieveWlbRecommendations

    public Map<Host,Set<String>> retrieveWlbRecommendations(Connection c)
                                                     throws Types.BadServerResponse,
                                                            Types.XenAPIException,
                                                            org.apache.xmlrpc.XmlRpcException

  Returns mapping of hosts to ratings, indicating the suitability of starting the VM at that location according to wlb. Rating is replaced with an error if the VM cannot boot there.

  Returns:
    The potential hosts and their corresponding recommendations or errors
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### copyBiosStringsAsync

    public Task copyBiosStringsAsync(Connection c,
                                     Host host)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Copy the BIOS strings from the given host to this VM

  Parameters:
    `host` - The host to copy the BIOS strings from
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### copyBiosStrings

    public void copyBiosStrings(Connection c,
                                Host host)
                         throws Types.BadServerResponse,
                                Types.XenAPIException,
                                org.apache.xmlrpc.XmlRpcException

  Copy the BIOS strings from the given host to this VM

  Parameters:
    `host` - The host to copy the BIOS strings from
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setProtectionPolicy

    public void setProtectionPolicy(Connection c,
                                    VMPP value)
                             throws Types.BadServerResponse,
                                    Types.XenAPIException,
                                    org.apache.xmlrpc.XmlRpcException

  Set the value of the protection_policy field

  Parameters:
    `value` - The value
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setStartDelayAsync

    public Task setStartDelayAsync(Connection c,
                                   Long value)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Set this VM's start delay in seconds

  Parameters:
    `value` - This VM's start delay in seconds
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setStartDelay

    public void setStartDelay(Connection c,
                              Long value)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException

  Set this VM's start delay in seconds

  Parameters:
    `value` - This VM's start delay in seconds
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setShutdownDelayAsync

    public Task setShutdownDelayAsync(Connection c,
                                      Long value)
                               throws Types.BadServerResponse,
                                      Types.XenAPIException,
                                      org.apache.xmlrpc.XmlRpcException

  Set this VM's shutdown delay in seconds

  Parameters:
    `value` - This VM's shutdown delay in seconds
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setShutdownDelay

    public void setShutdownDelay(Connection c,
                                 Long value)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException

  Set this VM's shutdown delay in seconds

  Parameters:
    `value` - This VM's shutdown delay in seconds
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setOrderAsync

    public Task setOrderAsync(Connection c,
                              Long value)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException

  Set this VM's boot order

  Parameters:
    `value` - This VM's boot order
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setOrder

    public void setOrder(Connection c,
                         Long value)
                  throws Types.BadServerResponse,
                         Types.XenAPIException,
                         org.apache.xmlrpc.XmlRpcException

  Set this VM's boot order

  Parameters:
    `value` - This VM's boot order
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setSuspendVDIAsync

    public Task setSuspendVDIAsync(Connection c,
                                   VDI value)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Set this VM's suspend VDI, which must be indentical to its current one

  Parameters:
    `value` - The suspend VDI uuid
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setSuspendVDI

    public void setSuspendVDI(Connection c,
                              VDI value)
                       throws Types.BadServerResponse,
                              Types.XenAPIException,
                              org.apache.xmlrpc.XmlRpcException

  Set this VM's suspend VDI, which must be indentical to its current one

  Parameters:
    `value` - The suspend VDI uuid
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### assertCanBeRecoveredAsync

    public Task assertCanBeRecoveredAsync(Connection c,
                                          Session sessionTo)
                                   throws Types.BadServerResponse,
                                          Types.XenAPIException,
                                          org.apache.xmlrpc.XmlRpcException,
                                          Types.VmIsPartOfAnAppliance,
                                          Types.VmRequiresSr

  Assert whether all SRs required to recover this VM are available.

  Parameters:
    `sessionTo` - The session to which the VM is to be recovered.
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmIsPartOfAnAppliance`
    `Types.VmRequiresSr`

### assertCanBeRecovered

    public void assertCanBeRecovered(Connection c,
                                     Session sessionTo)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException,
                                     Types.VmIsPartOfAnAppliance,
                                     Types.VmRequiresSr

  Assert whether all SRs required to recover this VM are available.

  Parameters:
    `sessionTo` - The session to which the VM is to be recovered.
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`
    `Types.VmIsPartOfAnAppliance`
    `Types.VmRequiresSr`

### recoverAsync

    public Task recoverAsync(Connection c,
                             Session sessionTo,
                             Boolean force)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException

  Recover the VM

  Parameters:
    `sessionTo` - The session to which the VM is to be recovered.
    `force` - Whether the VM should replace newer versions of itself.
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### recover

    public void recover(Connection c,
                        Session sessionTo,
                        Boolean force)
                 throws Types.BadServerResponse,
                        Types.XenAPIException,
                        org.apache.xmlrpc.XmlRpcException

  Recover the VM

  Parameters:
    `sessionTo` - The session to which the VM is to be recovered.
    `force` - Whether the VM should replace newer versions of itself.
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### importConvertAsync

    public static Task importConvertAsync(Connection c,
                                          String type,
                                          String username,
                                          String password,
                                          SR sr,
                                          Map<String,String> remoteConfig)
                                   throws Types.BadServerResponse,
                                          Types.XenAPIException,
                                          org.apache.xmlrpc.XmlRpcException

  Import using a conversion service.

  Parameters:
    `type` - Type of the conversion
    `username` - Admin username on the host
    `password` - Password on the host
    `sr` - The destination SR
    `remoteConfig` - Remote configuration options
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### importConvert

    public static void importConvert(Connection c,
                                     String type,
                                     String username,
                                     String password,
                                     SR sr,
                                     Map<String,String> remoteConfig)
                              throws Types.BadServerResponse,
                                     Types.XenAPIException,
                                     org.apache.xmlrpc.XmlRpcException

  Import using a conversion service.

  Parameters:
    `type` - Type of the conversion
    `username` - Admin username on the host
    `password` - Password on the host
    `sr` - The destination SR
    `remoteConfig` - Remote configuration options
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setApplianceAsync

    public Task setApplianceAsync(Connection c,
                                  VMAppliance value)
                           throws Types.BadServerResponse,
                                  Types.XenAPIException,
                                  org.apache.xmlrpc.XmlRpcException

  Assign this VM to an appliance.

  Parameters:
    `value` - The appliance to which this VM should be assigned.
  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### setAppliance

    public void setAppliance(Connection c,
                             VMAppliance value)
                      throws Types.BadServerResponse,
                             Types.XenAPIException,
                             org.apache.xmlrpc.XmlRpcException

  Assign this VM to an appliance.

  Parameters:
    `value` - The appliance to which this VM should be assigned.
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### queryServicesAsync

    public Task queryServicesAsync(Connection c)
                            throws Types.BadServerResponse,
                                   Types.XenAPIException,
                                   org.apache.xmlrpc.XmlRpcException

  Query the system services advertised by this VM and register them. This can only be applied to a system domain.

  Returns:
    Task
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### queryServices

    public Map<String,String> queryServices(Connection c)
                                     throws Types.BadServerResponse,
                                            Types.XenAPIException,
                                            org.apache.xmlrpc.XmlRpcException

  Query the system services advertised by this VM and register them. This can only be applied to a system domain.

  Returns:
    map of service type to name
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getAll

    public static Set<VM> getAll(Connection c)
                          throws Types.BadServerResponse,
                                 Types.XenAPIException,
                                 org.apache.xmlrpc.XmlRpcException

  Return a list of all the VMs known to the system.

  Returns:
    references to all objects
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

### getAllRecords

    public static Map<VM,VM.Record> getAllRecords(Connection c)
                                           throws Types.BadServerResponse,
                                                  Types.XenAPIException,
                                                  org.apache.xmlrpc.XmlRpcException

  Return a map of VM references to VM records for all VMs known to the system.

  Returns:
    records of all objects
  Throws:
    `Types.BadServerResponse`
    `Types.XenAPIException`
    `org.apache.xmlrpc.XmlRpcException`

Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD